<script setup lang="ts">
  import { computed } from 'vue';
  import { Product } from '@shopware-pwa/types';
  import { truncateTexts } from '~/helpers';
  import { formatInlineProduct } from '~/helpers/formatInlineProduct';

  const props = defineProps<{
    data: Product;
    readonly?: boolean;
    permissionGranted?: boolean;
  }>();

  const { t } = useI18n();
  const product = computed(() => props.data);
  const productId = computed(() => props.data.id);
  const loading = ref(false);

  const { quickViewModalController } = useQuickView();
  const { addToCart, loading: loadingAddToCart } = useAddToCart(product);
  const { unlike } = useLikeItem(productId);
  const { isSelfService } = useAppointment();
  const { requestDynamicPage } = useDynamicPage();

  const itemData = computed(() => formatInlineProduct(product.value));

  const isMainProduct = computed(() => {
    return !!(
      product.value.parentId === null &&
      product.value.childCount &&
      product.value.childCount > 0
    );
  });

  const handleRemove = async () => {
    loading.value = true;
    await unlike();
    loading.value = false;
  };

  const handleClick = () => {
    if (isSelfService.value) {
      requestDynamicPage({
        type: DynamicPageType.PRODUCT,
        productId: props.data.id,
      });
    } else {
      quickViewModalController.open(props.data.id);
    }
  };

  const namesTruncated = computed(() => {
    const listAttendeeNames = (product.value.extensions as any)?.wishlist?.attendees?.map(
      (x: any) => x.name || x.id,
    );
    const { texts, more } = truncateTexts(listAttendeeNames);
    return more ? `${texts} ${t('presentation.more', { count: more })}` : texts;
  });
</script>
<template>
  <SwInlineProductCard
    :data="itemData"
    :loading="loading"
    :readonly="readonly"
    @click="handleClick"
    @remove="handleRemove"
  >
    <template #product-meta>
      <SwTooltip
        v-if="!readonly"
        :disabled="permissionGranted"
        :content="$t('permissionToolTip')"
        position="topCenter"
        width="max-width"
      >
        <SwButton
          v-if="isMainProduct"
          variant="action"
          class="gap-1.5 !px-2"
          @click="handleClick()"
        >
          {{ $t('product.details') }}
        </SwButton>
        <SwButton
          v-else
          variant="action"
          class="gap-1.5 !px-2"
          :disabled="!permissionGranted"
          :loading="loadingAddToCart"
          @click="addToCart()"
        >
          <span class="i-sw-solid:shopping-cart text-sm" />
          {{ $t('product.addToCart') }}
        </SwButton>
      </SwTooltip>
      <SwTooltip v-else :content="namesTruncated" position="topCenter" width="max-width">
        <SwButton
          variant="action"
          class="!text-information border-transparent bg-gray-50 !px-2 shadow-none"
          disabled
        >
          <template #icon>
            <span class="i-sw-solid:heart text-(sm crimson-500) mr-1" />
          </template>
          <template #default>
            {{ (product?.extensions as any)?.wishlist?.count }}
          </template>
        </SwButton>
      </SwTooltip>
    </template>
    <template #product-price>
      <ProductPrice :product="product" layout="listing" :show-regulation-price="false" />
    </template>
  </SwInlineProductCard>
</template>
